//------------------------------------------------------------------------
// Project		: OHM_LCMXO2_4000HC BREAKOUT BOARD DEMO
// Module Name	: OHM_LCMXO2_4000HC
// Author		: Nick Petrescu
// Created		: 09/20/2019
//------------------------------------------------------------------------
// Description 	: Generic clock divider
//------------------------------------------------------------------------
// Modification history : 
//------------------------------------------------------------------------


module CLK_DIV 
	# (parameter divider = 10)
	(
	input 			clk,
	input 			rst_n,
	output 			clk_o
	);
	
	reg clk_o;
	integer i = 0;
	
	always @ (posedge clk or negedge rst_n) begin
		if(!rst_n) begin
			clk_o <= 0;
			i = 0;
		end
		else if (i < ((divider / 2) - 1)) begin
			clk_o <= 0;
			i = i + 1;
		end
		else if ((i == ((divider / 2) - 1)) || (i < (divider - 1))) begin
			clk_o <= 1;
			i = i + 1;
		end
		else if (i == divider - 1) begin 
			clk_o <= 0;
			i = 0;
		end
	end
endmodule